From e96c76f8f3306c65a97157ef75147bcfbc1a5d45 Mon Sep 17 00:00:00 2001
From: Kalle Valo <kvalo@codeaurora.org>
Date: Wed, 31 May 2017 08:07:53 +0300
Subject: [PATCH 2/3] pwcli: show: show the commit log from pending branch

If the patch is in pending branch, we should show the commit log from that
commit as it might be that it's edited.

Signed-off-by: Kalle Valo <kvalo@codeaurora.org>
---

Copyright (c) 2017, The Linux Foundation.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 cmdtests/cmd-review-stg-single.stdout |  2 +
 cmdtests/cmd-show-stg.script          | 58 ++++++++++++++++++++++++++++
 cmdtests/cmd-show-stg.stdout          | 73 +++++++++++++++++++++++++++++++++++
 pwcli                                 | 11 ++++--
 4 files changed, 141 insertions(+), 3 deletions(-)
 create mode 100755 cmdtests/cmd-show-stg.script
 create mode 100644 cmdtests/cmd-show-stg.stdout

diff --git a/cmdtests/cmd-review-stg-single.stdout b/cmdtests/cmd-review-stg-single.stdout
index 7615eee0cc7d..6ffbf303b36b 100644
--- a/cmdtests/cmd-review-stg-single.stdout
+++ b/cmdtests/cmd-review-stg-single.stdout
@@ -85,6 +85,8 @@ Timo Tiger <timo@example.com> wrote:
 > Foo commit log. Ignore this text
 > 
 > Signed-off-by: Dino Dinosaurus <dino@example.com>
+> ---
+> FIXME: add the patch here
 
 Patch applied to data.git, thanks.
 
diff --git a/cmdtests/cmd-show-stg.script b/cmdtests/cmd-show-stg.script
new file mode 100755
index 000000000000..8aa70439d008
--- /dev/null
+++ b/cmdtests/cmd-show-stg.script
@@ -0,0 +1,58 @@
+#!/usr/bin/env python
+#
+# Copyright (c) 2017, The Linux Foundation.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# 3. Neither the name of the copyright holder nor the names of its
+# contributors may be used to endorse or promote products derived from
+# this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+import cmdtestlib
+
+def test_stg(ctxt, pwcli):
+   pwcli.expect_prompt()
+   pwcli.sendline('list new')
+   pwcli.expect_prompt()
+   pwcli.sendline('review 1')
+   pwcli.expect(cmdtestlib.PROMPT_REVIEW_ACCEPT)
+   pwcli.sendline('a')
+   pwcli.expect(cmdtestlib.PROMPT_REVIEW_STATE)
+   pwcli.sendline('u')
+
+   pwcli.expect_prompt()
+   pwcli.sendline('list pending')
+
+   pwcli.expect_prompt()
+   pwcli.sendline('show 1')
+
+   pwcli.expect_prompt()
+   pwcli.sendline('quit')
+
+   print ctxt.smtpd.get_mails_as_string()
+
+if __name__ == "__main__":
+   cmdtestlib.StubContext.run_test(test_stg, stgit=True)
diff --git a/cmdtests/cmd-show-stg.stdout b/cmdtests/cmd-show-stg.stdout
new file mode 100644
index 000000000000..9eb406811ea2
--- /dev/null
+++ b/cmdtests/cmd-show-stg.stdout
@@ -0,0 +1,73 @@
+Connecting to http://localhost:8105/
+User          : test (7477, 30052, 118371)
+Projects      : stub-test
+Tree          : data
+Main branches : master
+Pending branch: pending
+New           : 18
+Review        : 0
+Upstream      : 0
+Deferred      : 5
+Total         : 23
+master@data > list new
+list new
+ [  1] foo: new patch                                               2011-02-11 Timo Tiger   New
+ [  2] foo: minor change with CC                                    2011-02-11 Timo Tiger   New
+ [  3] foo: another minor change with multiple To                   2011-02-11 Timo Tiger   New
+ [  4] [1/15] bar: blah blah blah 1                                 2011-02-11 Dino Dinosau New
+ [  5] [2/15] bar: blah blah blah 2                                 2011-02-11 Dino Dinosau New
+ [  6] [3/15] bar: blah blah blah 3                                 2011-02-11 Dino Dinosau New
+ [  7] [4/15] bar: blah blah blah 4                                 2011-02-11 Dino Dinosau New
+ [  8] [5/15] bar: blah blah blah 5                                 2011-02-11 Dino Dinosau New
+ [  9] [6/15] bar: blah blah blah 6                                 2011-02-11 Dino Dinosau New
+ [ 10] [7/15] bar: blah blah blah 7                                 2011-02-11 Dino Dinosau New
+ [ 11] [8/15] bar: blah blah blah 8                                 2011-02-11 Dino Dinosau New
+ [ 12] [9/15] bar: blah blah blah 9                                 2011-02-11 Dino Dinosau New
+ [ 13] [10/15] bar: blah blah blah 10                               2011-02-11 Dino Dinosau New
+ [ 14] [11/15] bar: blah blah blah 11                               2011-02-11 Dino Dinosau New
+ [ 15] [12/15] bar: blah blah blah 12                               2011-02-11 Dino Dinosau New
+ [ 16] [13/15] bar: blah blah blah 13                               2011-02-11 Dino Dinosau New
+ [ 17] [14/15] bar: blah blah blah 14                               2011-02-11 Dino Dinosau New
+ [ 18] [15/15] bar: blah blah blah 15                               2011-02-11 Dino Dinosau New
+master@data > review 1
+review 1
+Retrieving patches (1/1)
+      foo: new patch                                               2011-02-11 Timo Tiger   New
+------------------------------------------------------------
+Apply 1 patches to the pending branch? [Apply/Skip/aBort] a
+a
+Importing patches (1/1)
+                                                                   CC foo.c                                                                   CC bar.c                                                                   CC aaa.c                                                                   CC bbb.c                                                                 Build successful
+Under review/Changes requested/Rejected/New/Deferred/Superseded/aWaiting upstreamm/not aPplicable/rFc/aBort? u
+u
+Setting patch state (1/1)
+Patch set to Under Review
+master@data > list pending
+list pending
+*[  1] foo: new patch                                               2011-02-11 Timo Tiger   Under Review
+master@data > show 1
+show 1
+Delegate: test
+State: Under Review
+From: Timo Tiger <timo@example.com>
+Date: 2011-02-11 05:23:31
+Patchwork-Id: 1030
+Patchwork-URL: http://localhost:8105/1030/
+PendingCommit: 627a93a4aa38417e4d130d02240fc54d21893024
+FinalCommit: None
+CommitRef: 
+PatchIndex: None
+StgIndex: 0
+============================================================
+foo: new patch
+
+Foo commit log. Ignore this text
+
+Signed-off-by: Dino Dinosaurus <dino@example.com>
+---
+FIXME: add the patch here
+---
+ 0 files changed
+============================================================
+master@data > quit
+
diff --git a/pwcli b/pwcli
index f7d068a0f6cb..5e5c1c28ce97 100755
--- a/pwcli
+++ b/pwcli
@@ -790,10 +790,15 @@ class Patch():
         return reply
 
     def get_log(self):
-        msg = self.get_email()
-        payload = msg.get_payload()
+        if self.pending_commit is not None:
+            log = self.pending_commit.log
 
-        (log, sep, patch) = payload.partition(LOG_SEPARATOR)
+            # remove Patchwork-Id
+            log = re.sub(r'\n\s*Patchwork-Id:\s*\d+\s*\n', '\n', log)
+        else:
+            msg = self.get_email()
+            payload = msg.get_payload()
+            (log, sep, patch) = payload.partition(LOG_SEPARATOR)
 
         return log.strip()
 
-- 
2.7.4

